SystemOrganization addCategory: #'Seaside-Tests-Playground'!

Object subclass: #PGPlugin
	instanceVariableNames: 'selected component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

PGPlugin subclass: #PGFormTagPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!PGFormTagPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:25'!
label
	^'- Form Tags -'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:33'!
tempateList
	^'html select list: #(1 2 3 4 5);
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:33'!
tempateListOptional
	^'html select list: #(1 2 3 4 5);
   beOptional;
   optionalLabel: ''(none)'';
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:30'!
templateCancelButton
	^'html cancelButton value: ''Cancel''.'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:32'!
templateCheckBox
	^'html checkbox
   callback: [:value | values at: #checkbox1 put: value];
   value: (values at: #checkbox1 ifAbsent: [false]);
   with: ''Checkbox 1''.'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:32'!
templateFileUpload
	^'html fileUpload callback: [ :f | values at: #file put: f fileName ].' ! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:32'!
templateForm
	^'html form: [  ].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:32'!
templateFormMultipart
	^'html form multipart; with: [  ].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:34'!
templateList
	^'html select list: #(1 2 3 4 5);
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:34'!
templateMultiList
	^'html multiSelect list: #(11 12 13 14 15);
   size: 4;
   selected: (values at: #multiList1 ifAbsent: []);
   callback: [:v | values at: #multiList1 put: v].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:34'!
templatePasswordInput
	^'html passwordInput
   callback: [:value | values at: #password1 put: value];
   value: (values at: #password1 ifAbsent: ['''']).'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:34'!
templateRadioButton
	^'html radioGroup
   callback: [:value | values at: #radio1 put: value];
   selected: (values at: #radio1 ifAbsent: []);
   with: [:group | 
    #(''Radio 1'' ''Radio 2'') do: [:each |
     group radioButton value: each.
     html text: each.
     html break]].'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:34'!
templateResetButton
	^'html button beReset; with: ''Reset''.'.! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:35'!
templateSubmitButton
	^'html submitButton callback: []; value: ''OK''.'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:35'!
templateTextArea
	^'html textArea
   rows: 5;
   columns: 60;
   callback: [:value | values at: #text1 put: value];
   value: (values at: #text1 ifAbsent: ['''']).'! !

!PGFormTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:35'!
templateTextInput
	^'html textInput
   callback: [:value | values at: #input1 put: value];
   value: (values at: #input1 ifAbsent: ['''']).'! !

PGPlugin subclass: #PGJQueryTagPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!PGJQueryTagPlugin class methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:40'!
priority
	^200! !

!PGJQueryTagPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:36'!
label
	^'- JQuery Tags -'! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:36'!
templateAnchorClick
	^'html anchor onClick: (html javascript alert: ''Test''); with: ''Click me''.'! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:37'!
templateEffectBounce
	^'html anchor onClick: ((html jQuery: ''.box'') effect bounce; easing: ''linear''; times: 2); with: ''Bounce''.'.! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:37'!
templateEffectHighlight
	^'html anchor onClick: ((html jQuery: ''.box'') effect speed: 2000); with: ''Highlight''.'.! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:37'!
templateEffectPulsate
	^'html anchor onClick: ((html jQuery: ''.box'') effect pulsate times: 2); with: ''Pulsate''.'.! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:37'!
templateEffectShake 
	^'html anchor onClick: ((html jQuery: ''.box'') effect shake; distance: 5; times: 3); with: ''Shake''.'.! !

!PGJQueryTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:41'!
templateFormSubmit
	^'html anchor onClick: (html jQuery ajax serializeForm); with: ''OK''.'.! !

!PGPlugin class methodsFor: 'instance creation' stamp: 'obi 1/15/2010 11:39'!
on: aComponent
	^self new component: aComponent; yourself! !

!PGPlugin class methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:27'!
priority
	^100! !

!PGPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 11:39'!
component
	^ component! !

!PGPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 11:39'!
component: anObject
	component := anObject! !

!PGPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 07:38'!
label
	^self subclassResponsibility ! !

!PGPlugin methodsFor: 'private' stamp: 'obi 1/15/2010 11:35'!
labelFor: aSelector
	^aSelector copyFrom: 9 to: aSelector size! !

!PGPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 08:01'!
list
	^self templates collect: [:each | each -> (self labelFor: each)]! !

!PGPlugin methodsFor: 'private' stamp: 'obi 1/15/2010 11:48'!
onChangeScriptOn: html
	^html jQuery ajax
		serializeForm;
		serializeForm: (html jQuery: #formCode);
		callback: [ :value | component currentPosition: value asNumber ] value: (JSStream on: 'getCursorPosition()') ;
		script: [:script | self updateOn: script]! !

!PGPlugin methodsFor: 'rendering' stamp: 'obi 1/15/2010 11:35'!
renderOn: html
	html select
		onChange: (self onChangeScriptOn: html);
		list: self list;
		labels: [:assoc | assoc value];
		beOptional;
		optionalLabel: self label;
		callback: [:value | selected := value. ].! !

!PGPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 07:44'!
templates
	^(self class selectors select: [:each | 'template*' match: each asString ]) asSortedCollection! !

!PGPlugin methodsFor: 'updating' stamp: 'obi 1/15/2010 11:51'!
updateOn: script
	| codePart |
	selected isNil ifTrue: [^self].
	codePart := self perform: selected key.
	component updateWith: codePart on: script.
	selected := nil! !

PGPlugin subclass: #PGSimpleTagPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!PGSimpleTagPlugin class methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:27'!
priority
	^1! !

!PGSimpleTagPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 07:39'!
label
	^'- Simple Tags -'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:09'!
templatEemphasis
	^'html emphasis: ''Emphasis test''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:12'!
templateAnchorCallback
	^'html anchor callback: []; with: ''Click me''.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:10'!
templateBig
	^'html big: ''BIG''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 07:40'!
templateBreak
	^'html break.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:09'!
templateCitation
	^'html citation: ''Defines a citation.''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:09'!
templateCode
	^'html code: ''_Smalltalk_ code would be fine.''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 07:41'!
templateDiv
	^'html div: [  ].'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 07:42'!
templateDivBox
	^'html div class: ''box''.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:10'!
templateHeading
	^'html heading level2; with: ''Title''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:09'!
templateHorizontalRule
	^'html horizontalRule.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:11'!
templateHtml
	 ^'html html: ''<div>HTML Test</div>''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:10'!
templateIframe 
	^'html iframe width: 900; height: 300; url: ''http://www.seaside.st''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:11'!
templateImage
	^'html image
	  title: ''Seaside'';
	  altText: ''The Seaside logo'';
	  url: ''http://www.seaside.st/styles/logo-plain.png''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:42'!
templateLabel
	^'html label: ''Label 1''.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:10'!
templateOrderedList
	^'html orderedList list: #(''A'' ''B'' ''C'').'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 07:41'!
templateParagraph
	^'html paragraph.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:12'!
templatePopUpAnchor
	^'html popupAnchor
  resizable: false;
  extent: 300 @ 300;
  position: 50 @ 50;
  callback: [ thisComponent inform: ''Hello'' ];
  with: ''Open popup''.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:11'!
templateSpace
	^'html space.'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:07'!
templateSpan
	^'html span: [  ].'.! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 07:42'!
templateText
	^'html div class: ''box''.'! !

!PGSimpleTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:11'!
templateUnorderedList
	^'html unorderedList list: #(''A'' ''B'' ''C'').'.! !

PGPlugin subclass: #PGTableTagPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!PGTableTagPlugin methodsFor: 'accessing' stamp: 'obi 1/15/2010 12:17'!
label
	^'- Table Tags -'! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:19'!
templatTableRow 
	^'html tableRow: [  ].'.! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:18'!
templateTable
	^'html table: [  ].'.! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:21'!
templateTableContainer
	^'html table: [
   html tableRow: [
     html tableData: [].
     html tableData: []].
   html tableRow: [
     html tableData: [].
     html tableData: []].
   ].'! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:18'!
templateTableData
	^'html tableData: [  ].'.! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:18'!
templateTableHeading
	^'html tableHeading: [  ].'.! !

!PGTableTagPlugin methodsFor: 'templates' stamp: 'obi 1/15/2010 12:19'!
templateTableWithHeader
	^'html table: [
   html tableRow: [
     html tableHeading: ''Header 1''.
     html tableHeading: ''Header 2''].
   html tableRow: [
     html tableData: ''Data 1''.
     html tableData: ''Data 2''].
   ].'! !

WAComponent subclass: #WAPlaygroundComponent
	instanceVariableNames: 'code callbackValues currentPosition history saved msValue privateStyle'
	classVariableNames: 'Log'
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
description
	^ 'Seaside playground'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 13:04'!
exampleCode
^'html big: ''TEST Playground''.
html form: [
 html multiSelect list: #(11 12 13 14 15);
   selected: (values at: #list ifAbsent: []);
   callback: [:v | values at: #list put: v ].
 html break.
 html textInput value: (values at: #input ifAbsent: []);  callback: [:v | values at: #input put: v].
 html break.
html submitButton value: ''OK'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/2/2010 20:39'!
exampleJQCode
^'html anchor
 onClick: ((html jQuery: #itsme) fadeIn: 1 seconds);
 with: ''Show''.
html space: 2.
html anchor
 onClick: ((html jQuery: #itsme) hide: 1 seconds);
 with: ''Hide''.
html div id: ''itsme'';
 style: ''border:1px solid #ccc;width:100px;background:#fee'';
 with: [
  html div: ''I am DIV''.
  html div: ''with some text....'']'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
handlerName
	^'examples/playground'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/11/2010 21:01'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: self handlerName.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary.
	Log := false! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:39'!
log: aBoolean
	"Log := true"
	Log := aBoolean! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:39'!
logEnabled
	^Log == true! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:36'!
addToHistory
	history isEmpty ifFalse: [history last = code ifTrue: [ ^self ] ].
	history add: code! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/13/2010 20:55'!
buildCode
	^'[:html :values :thisComponent | ', code ,']'! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:51'!
callbackValuesString
	| stream |
	stream := WriteStream on: String new.
	callbackValues keysAndValuesDo: [:k :v |
		stream nextPutAll: k asString, ' -> ', v printString.
		stream cr.].
	^stream contents! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:12'!
clearCallbackValues
	callbackValues := Dictionary new! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code
	^code! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:52'!
code: aString
	aString = code
		ifFalse: [
			code := aString.
			self log: aString ]! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/15/2010 11:41'!
currentPosition
	^ currentPosition! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/15/2010 11:41'!
currentPosition: anObject
	^ currentPosition := anObject! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/4/2010 14:41'!
getCursorPositionScript
^'function getCursorPosition()
{
var obj=document.getElementById(''code'');
var CurPos = 0;
//FOR IE
if (document.selection)
{
obj.focus ();
var Sel = document.selection.createRange();
Sel.moveStart (''character'', -obj.value.length);
CurPos = Sel.text.length;
}
// For Firefox
else {CurPos = obj.selectionStart}
return CurPos;
}'! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/3/2010 20:38'!
historyBack
	history size > 1
		ifTrue: [
			history removeLast.
			code := history last ].
! !

!WAPlaygroundComponent methodsFor: 'initialization' stamp: 'obi 1/11/2010 22:02'!
initialize
	super initialize.
	code := ''.
	callbackValues := Dictionary new.
	saved := Dictionary new.
	history := OrderedCollection new.
	privateStyle := ''! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/13/2010 10:25'!
isSecure: aText
	| codeParts notAllowedSelectors notAllowedSubStrings |
	notAllowedSelectors := #('class' 'self' 'super' 'superclass' 'thisContext').
	notAllowedSubStrings := #('compile*' '*fileIn*' 'environment*' 'valueWithReceiver*' 'retrieve*' '*exchangeIdentity*' '*forwardIdent*' 'snapshot*' '*methodDict*' 'instVar*' 'browse*' 'become*' 'halt*' '*evaluate*' 'evalString*' 'explore*' 'basic*' 'perform*' 'inspect*').
	codeParts := self split: aText.
	codeParts do: [:str | str isEmpty
			ifFalse: [
				(str includes: ${) ifTrue: [^false ].
				str first isUppercase
					ifFalse: [
						(notAllowedSelectors includes: str) ifTrue: [^false ].
						 notAllowedSubStrings do: [:each | (each match: str) ifTrue: [^false]]]
					ifTrue: [
						(Smalltalk at: str asSymbol ifAbsent: []) isNil ifFalse: [^false ] ] ] ].
	^true! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:21'!
loadExample
	code := self class exampleCode! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:52'!
loadJQExample
	code := self class exampleJQCode! !

!WAPlaygroundComponent methodsFor: 'logging' stamp: 'obi 1/12/2010 08:33'!
log: aString
	self class logEnabled ifTrue: [
		| fileStream |
		fileStream := FileStream fileNamed: (Date today asString, '_seaside.log')  asFileName.
		fileStream text; setToEnd.
		[fileStream nextPutAll: TimeStamp current asString; crlf; nextPutAll: aString; crlf.
		fileStream nextPutAll: '---------------------------------------------------------------------------------------------------------------------------------'; crlf] ensure: 
			[fileStream close] ]! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 22:06'!
privateStyle
	^ privateStyle! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 22:06'!
privateStyle: anObject
	privateStyle := anObject! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/5/2010 19:10'!
renderCodeOn: html
	html div id: 'codeDiv';
		with: [
			 html textArea id: 'code'; columns: 100; rows: 20; on: #code of: self ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/15/2010 11:36'!
renderContentOn: html
	html script: self setCursorPositionScript.
	html script: self getCursorPositionScript.
	html heading level3; with: 'Seaside playground'.
	html div id: 'output'; 
		with: [self renderOutputOrErrorOn: html].
	
	html form: [
			html table: [
				html tableRow: [
					html
						tableHeading style: 'width:820px';
							with: [
								html div id: 'lists';
									with: [self renderPluginsOn: html ] ].
					html tableHeading style: 'width:265px'; with: [ html anchor onClick: ((html jQuery: #valuesDiv) load html: [:r | self renderValuesOn: r]); with: 'Values' ].
					html tableHeading: 'Styles' ] ] ].
	html form id: 'formCode';
		with: [
		html table: [
			html tableRow: [
				html tableData: [ self renderCodeOn: html].
				html tableData: [self renderValuesOn: html].
				html tableData: [self renderStyleOn: html] ] .
			html tableRow: [
				html tableData: [
					html submitButton value: 'Save'; callback: [self addToHistory].
					html space.
					html submitButton value: 'Reset'; callback: [self clearCallbackValues].
					html space.
					html button value: 'Undo'; callback: [self historyBack].
					html space.
					html submitButton value: 'Clear'; callback: [code := ''. self clearCallbackValues].
					html space.
					html submitButton value: 'Example'; callback: [self loadExample ].
					html space.
					html submitButton value: 'JQ Example'; callback: [self loadJQExample ].].
				html tableData
					id: 'timeValue';
					with: [self renderTimeValueOn: html] ]  ] ].
	    ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/13/2010 21:06'!
renderOutputOn: html
	| ms aBlock |
	[aBlock := Compiler evaluate: self buildCode.
	ms := Time millisecondClockValue.
	aBlock value: html value: callbackValues value: self.
	msValue := (Time millisecondClockValue - ms) asString, ' ms'.  ] on: Halt, Error, Warning, ParserNotification do: [:ex | html div class: 'error'; with: ex ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 21:51'!
renderOutputOrErrorOn: html
	| ms |
	msValue := 'NA'.
	(self isSecure: code) 
				ifTrue: [ms := Time millisecondClockValue.
						self renderOutputOn: html.
						msValue := (Time millisecondClockValue - ms) asString, ' ms'. ]
				ifFalse: [html div class: 'error'; with: 'Due security restrictions you are not allowed to execute the entered code!!' ]
				 ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/15/2010 12:28'!
renderPluginsOn: html
	(PGPlugin allSubclasses asSortedCollection: [:a :b | a priority < b priority ])
		do: [:each | html render: (each on: self)] separatedBy: [html space]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:07'!
renderStyleOn: html
	html div id: 'styleDiv';
		with: [ html textArea columns: 40; rows: 20; on: #privateStyle of: self]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:27'!
renderTimeValueOn: html
	html span style: 'color:#eee'; with: 'Rendering time: ', msValue
	    ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:24'!
renderValuesOn: html
	html div id: 'valuesDiv';
		with: [ html textArea columns: 30; rows: 20; value: self callbackValuesString]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/4/2010 14:33'!
setCursorPositionScript
^'function setCursorPosition(pos)
{
var obj=document.getElementById(''code'');

//FOR IE
if(obj.setSelectionRange)
{
obj.focus();
obj.setSelectionRange(pos,pos);
}

// For Firefox
else if (obj.createTextRange)
{
var range = obj.createTextRange();
range.collapse(true);
range.moveEnd(''character'', pos);
range.moveStart(''character'', pos);
range.select();
}
}'! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/12/2010 07:38'!
split: aString 
	| lines in out c |
	lines := OrderedCollection new.
	in := aString readStream.
	out := String new writeStream.
	[ in atEnd ] whileFalse: 
		[ ((c := in next) isSeparator or: [c == $. or: [c == $; or: [c == $# or: [c == $' or: [c == $( or: [c == $[ or: [c == $) or: [c == $] or: [c == $}] ]]]]]]]])
			ifTrue: 
				[out position = 0 ifFalse: [ lines add: out contents ].
				out reset ]
			ifFalse: [ out nextPut: c ] ].
	out position = 0 ifFalse: [ lines add: out contents ].
	^ lines! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:28'!
style
	^'html { overflow-y: scroll; }
body { margin: 0; padding: 0; background: #434242 url(background.png) repeat-x; font-family: Helvetica,Arial,Verdana,sans-serif; font-size: 80%; line-height: 1.5; color: #222; }
a { text-decoration: none; color: #ff7200; outline: none; cursor: pointer; }
h1, h2, h3, h4, h5, h6 { border: 0; margin: 0; font-weight: normal; letter-spacing: 1px; }
	
h3, th  {
color:#FF7200;
font-size:20px;
margin-bottom:6px;}
th {text-align:left}
.error {color:red;font-size:14px;font-family:verdana}
 #output {background:#fff;height:400px;overflow:auto;border:1px solid #ccc;padding:4px;margin:4px}
.box {width:50px;height:50px;background:blue;border:2px solid black;}
', privateStyle! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:39'!
theme
	^JQBaseTheme default! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/9/2010 18:53'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	self theme updateRoot: anHtmlRoot! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/15/2010 12:04'!
updateWith: codePart on: script
	| code1 code2 newPosition index offset |
	
	index := codePart findString: '[  ]' startingAt: 1 .
	offset := index > 0 ifTrue: [offset := index - codePart size + 1] ifFalse: [0].
	currentPosition < code size
		ifTrue: [	code1 := code copyFrom: 1 to: currentPosition.
				code2 := code copyFrom: currentPosition + 1 to: code size.
				code := code1,'
  ' , codePart , code2.
	newPosition := currentPosition + codePart size + 3. ]
		ifFalse: [
			code isEmpty 
				ifTrue: [code := ' ', codePart]
				ifFalse: [code := code, '
  ',codePart ]. 
			newPosition := code size ].
	newPosition := newPosition + offset.	
	script add: ((script jQuery id: 'codeDiv') html: [:r | self renderCodeOn: r]).
	script add: ((script jQuery id: 'lists') html: [:r | self renderPluginsOn: r]).
	script add: ((script jQuery id: 'output') html: [:r | self renderOutputOrErrorOn: r]).
	script add: ((script jQuery id: 'timeValue') html: [:r | self renderTimeValueOn: r]).

	script add: (JSStream on: 'setCursorPosition(', newPosition asString, ')').
	self addToHistory! !
WAPlaygroundComponent initialize!
